//#ifndef STDFER_H
//#define STDFER_H

#if _MSC_VER > 1000
#pragma once
#endif

#ifndef MALLOC_H
#define MALLOC_H

#include <sys/types.h>

#ifdef  __cplusplus
extern "C" {
#endif

void *malloc(size_t size);
void *realloc(void *mem, size_t size);
void *calloc(size_t num, size_t size);
void free(void *p);

void  *_alloca(size_t size);
#define alloca _alloca

#ifdef  __cplusplus
}
#endif

#endif

int isspace(int c);

int isdigit(int c);

long atol(const char *nptr);

int atoi(const char *nptr);

double atof(char *s);

//#endif
